package com.jojubanking.boot.module.system.service.kstype;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.kstype.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.kstype.KsTypeDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.kstype.KsTypeConvert;
import com.jojubanking.boot.module.system.dal.mysql.kstype.KsTypeMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 科室类别 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class KsTypeServiceImpl implements KsTypeService {

    @Resource
    private KsTypeMapper ksTypeMapper;

    @Override
    public Integer createKsType(KsTypeCreateReqVO createReqVO) {
        // 插入
        KsTypeDO ksType = KsTypeConvert.INSTANCE.convert(createReqVO);
        ksTypeMapper.insert(ksType);
        // 返回
        return ksType.getId();
    }

    @Override
    public void updateKsType(KsTypeUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateKsTypeExists(updateReqVO.getId());
        // 更新
        KsTypeDO updateObj = KsTypeConvert.INSTANCE.convert(updateReqVO);
        ksTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteKsType(Integer id) {
        // 校验存在
        this.validateKsTypeExists(id);
        // 删除
        ksTypeMapper.deleteById(id);
    }

    private void validateKsTypeExists(Integer id) {
        if (ksTypeMapper.selectById(id) == null) {
            throw exception(KS_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public KsTypeDO getKsType(Integer id) {
        return ksTypeMapper.selectById(id);
    }

    @Override
    public List<KsTypeDO> getKsTypeList(Collection<Integer> ids) {
        return ksTypeMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<KsTypeDO> getKsTypePage(KsTypePageReqVO pageReqVO) {
        return ksTypeMapper.selectPage(pageReqVO);
    }

    @Override
    public List<KsTypeDO> getKsTypeList(KsTypeExportReqVO exportReqVO) {
        return ksTypeMapper.selectList(exportReqVO);
    }

}
